angular.module('app.directives', [])

.directive('focusMe', function($timeout, $parse) {
  return {
    link: function(scope, element, attrs) {
      var model = $parse(attrs.focusMe);
      scope.$watch(model, function(value) {
        if(value) {
          $timeout(function() {
            element[0].focus();
            element[0].click();
          }, 100);
        }
      });
    }
  };
})

.directive('profileMenu', function($ionicPlatform, $ionicSideMenuDelegate, $cordovaSQLite, $state, ProfilesService) {
  return {
    restrict: 'E',
    templateUrl: 'templates/directives/profileMenu.html',
    link: function(scope, element, attrs) {
      scope.profiles = [];

      scope.$watch(function () {
        return $ionicSideMenuDelegate.getOpenRatio();
      }, function (ratio) {
        if (ratio == 1){
          ProfilesService.reloadProfiles().then(function(data) {
            scope.profiles = data;
          });
        }
      });

      ProfilesService.getProfiles().then(function(data) {
        scope.profiles = data;
      });

      scope.selectProfile = function(profile) {
        ProfilesService.setCurrentProfile(profile);
        $ionicSideMenuDelegate.toggleLeft(false);
        $state.go('tabsController.profile');
      };

      scope.createProfile = function() {
        ProfilesService.createProfile();
        $ionicSideMenuDelegate.toggleLeft(false);
        $state.go('tabsController.profile');
      };

      scope.deleteProfile = function(profile, index) {
        ProfilesService.deleteProfile(profile, index);
      };

      scope.upgradeToPro = function() {
        if(ionic.Platform.isAndroid()) {
          window.open('market://details?id=com.tntgames.pathfinderspellbook', '_system');
        } else {
          window.open('itms-apps://itunes.apple.com/us/app/spellbook-for-pathfinder/id1118206888?ls=1&mt=8');
        }
      };
    }
  };
});
