angular.module('app.routes', ['ionicUIRouter'])

.config(function($stateProvider, $urlRouterProvider) {
  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider.state('tabsController.profile', {
    url: '/profile',
    views: {
      'tab1': {
        templateUrl: 'templates/profile.html',
        controller: 'profileCtrl'
      }
    }
  })

  .state('tabsController.memorized', {
    url: '/memorized/:id',
    views: {
      'tab1': {
        templateUrl: 'templates/memorized.html',
        controller: 'memorizedCtrl'
      }
    }
  })

  .state('tabsController.spells', {
    url: '/spells',
    views: {
      'tab4': {
        templateUrl: 'templates/spells.html',
        controller: 'spellsCtrl'
      }
    }
  })

  .state('tabsController.allSpells', {
    url: '/allSpells',
    views: {
      'tab5': {
        templateUrl: 'templates/allSpells.html',
        controller: 'allSpellsCtrl'
      }
    }
  })

  .state('tabsController', {
    url: '/home',
    templateUrl: 'templates/tabsController.html',
    abstract:true
  })

  /*
    The IonicUIRouter.js UI-Router Modification is being used for this route.
    To navigate to this route, do NOT use a URL. Instead use one of the following:
      1) Using the ui-sref HTML attribute:
        ui-sref='tabsController.spell'
      2) Using $state.go programatically:
        $state.go('tabsController.spell');
    This allows your app to figure out which Tab to open this page in on the fly.
    If you're setting a Tabs default page or modifying the .otherwise for your app and
    must use a URL, use one of the following:
      /home/tab4/spell/:id
      /home/tab2/spell/:id
      /home/tab3/spell/:id
      /home/tab5/spell/:id
  */
  .state('tabsController.spell', {
    url: '/spell/:id',
    views: {
      'tab4': {
        templateUrl: 'templates/spell.html',
        controller: 'spellCtrl'
      },
      'tab2': {
        templateUrl: 'templates/spell.html',
        controller: 'spellCtrl'
      },
      'tab3': {
        templateUrl: 'templates/spell.html',
        controller: 'spellCtrl'
      },
      'tab5': {
        templateUrl: 'templates/spell.html',
        controller: 'spellCtrl'
      },
      'tab1': {
        templateUrl: 'templates/spell.html',
        controller: 'spellCtrl'
      }
    }
  })

  .state('tabsController.levels', {
    url: '/levels',
    views: {
      'tab2': {
        templateUrl: 'templates/levels.html',
        controller: 'levelsCtrl'
      }
    }
  })

  .state('tabsController.schools', {
    url: '/schools',
    views: {
      'tab3': {
        templateUrl: 'templates/schools.html',
        controller: 'schoolsCtrl'
      }
    }
  })



$urlRouterProvider.otherwise('/home/profile')



});
