function ProfilesService() {

}

angular.module('app.services', []).factory('ProfilesService', function($q, $cordovaSQLite, $ionicPlatform, $rootScope) {
  var profiles = $q.defer();
  var currentProfile = $q.defer();

  function getProfiles() {
      return profiles.promise;
  }

  function getCurrentProfile() {
    return currentProfile.promise;
  }

  function setCurrentProfile(newProfile) {
    currentProfile.promise.then(function(oldProfile) {
      var hasSwitchedProfile = oldProfile == null || oldProfile.id != newProfile.id;
      currentProfile = null;
      currentProfile = $q.defer();
      currentProfile.resolve(newProfile);
      if(hasSwitchedProfile) {
        $rootScope.$emit('onProfileChange', newProfile);
      }
    });
  }

  function createProfile() {
    var newProfileQuery = "insert into Profiles (name, class_id, is_default) values ('', 1, " + (profiles.length == 0 ? 1 : 0) + ")";
    var defaultProfileSourcesQuery = "insert into ProfileSources (source_id, profile_id) values (?, ?)";
    $cordovaSQLite.execute(profileDb, newProfileQuery, []).then(function(res) {
      $cordovaSQLite.execute(profileDb, "select * from Profiles where id = (select last_insert_rowid())", []).then(function(res) {
        setCurrentProfile(res.rows.item(0));
        var coreRulebookId = 1; //todo: don't hardcode this
        $cordovaSQLite.execute(profileDb, defaultProfileSourcesQuery, [coreRulebookId, res.rows.item(0).id]);
      }, function (err) {
          console.error(JSON.stringify(err));
      });
    }, function (err) {
        console.error(JSON.stringify(err));
    });
  }

  function reloadProfiles() {
    profiles = $q.defer();
    loadProfiles();
    return getProfiles();
  }

  function deleteProfile(profile, index) {
    var query = "delete from Profiles where id = ?";
    $cordovaSQLite.execute(profileDb, query, [profile.id]).then(function(res) {
      
      profiles.promise.then(function(profiles) {
        profiles.splice(index,1);
      });

      query = "delete from ProfileSources where profile_id = ?";
      $cordovaSQLite.execute(profileDb, query, [profile.id]).then(function(res) {
      },
      function(error) {
        console.log(JSON.stringify(error));
      });

      query = "delete from ProfileSpells where profile_id = ?";
      $cordovaSQLite.execute(profileDb, query, [profile.id]).then(function(res) {
      },
      function(error) {
        console.log(JSON.stringify(error));
      });

      $rootScope.$emit('onProfileDelete', profile);
    },
    function(error) {
      console.log(JSON.stringify(error));
    });
  }

  var loadProfiles = function() {
    var query = "select id, name, class_id, is_default, mystery_id from Profiles order by is_default desc";

    $cordovaSQLite.execute(profileDb, query, []).then(function(res) {
      var profilesData = [];
      for(var i = 0; i < res.rows.length; i++) {
        profilesData.push(res.rows.item(i));
      }

      if(profilesData.length > 0) {
        currentProfile.resolve(profilesData[0]);
      } else {
        currentProfile.resolve(null);
      }
      profiles.resolve(profilesData);
    }, function (err) {
        console.error(JSON.stringify(err));
    });
  };

  loadProfiles();
  
  return {
    getProfiles: getProfiles,
    getCurrentProfile: getCurrentProfile,
    setCurrentProfile: setCurrentProfile,
    createProfile: createProfile,
    reloadProfiles: reloadProfiles,
    deleteProfile: deleteProfile
  };
});
